<?php

namespace Amazingcat\Labels\Model\Source;

use Amazingcat\Labels\Model\DefaultLabelFactory;
use Amazingcat\Labels\Model\ResourceModel\DefaultLabel as ResourceDefaultLabel;
use Amazingcat\Labels\Model\ResourceModel\DefaultLabel\CollectionFactory;
use Magento\Eav\Model\Entity\Attribute\Source\AbstractSource;

/**
 * Class DefaultLabelSource
 * @package Amazingcat\Labels\Model\Source
 */
class DefaultLabelSource extends AbstractSource
{
    /**
     * @var DefaultLabelFactory
     */
    protected $labelFactory;

    /**
     * @var ResourceDefaultLabel
     */
    protected $labelResource;

    /**
     * @var CollectionFactory
     */
    protected $labelCollectionFactory;

    /**
     * DefaultLabelSource constructor.
     * @param DefaultLabelFactory $labelFactory
     * @param ResourceDefaultLabel $labelResource
     * @param CollectionFactory $labelCollectionFactory
     */
    public function __construct(
        DefaultLabelFactory $labelFactory,
        ResourceDefaultLabel $labelResource,
        CollectionFactory $labelCollectionFactory
    ) {
        $this->labelFactory = $labelFactory;
        $this->labelResource = $labelResource;
        $this->labelCollectionFactory = $labelCollectionFactory;
    }

    /**
     * @return array
     */
    public function getAllOptions()
    {
        $collection = $this->labelCollectionFactory->create();
        $defaultLabels = $collection->getData();
        $result = [
            [
                'value' => 0,
                'label' => 'none'
            ],
        ];

        foreach ($defaultLabels as $defaultLabel) {
            $data = [
                'value' => $defaultLabel['id'],
                'label' => $defaultLabel['name']
            ];
            array_push($result, $data);
        }

        return $result;
    }
}
