<?php

namespace Amazingcat\Labels\Model\Source;

use Amazingcat\Labels\Model\DefaultLabelFactory;
use Amazingcat\Labels\Model\ResourceModel\DefaultLabel as ResourceDefaultLabel;
use Amazingcat\Labels\Model\ResourceModel\DefaultLabel\CollectionFactory;
use Magento\Eav\Model\Entity\Attribute\Source\AbstractSource;

/**
 * Class PositionSource
 * @package Amazingcat\Labels\Model\Source
 */
class PositionSource extends AbstractSource
{
    /**
     * @var DefaultLabelFactory
     */
    protected $labelFactory;

    /**
     * @var ResourceDefaultLabel
     */
    protected $labelResource;

    /**
     * @var CollectionFactory
     */
    protected $labelCollectionFactory;

    /**
     * DefaultLabelSource constructor.
     * @param DefaultLabelFactory $labelFactory
     * @param ResourceDefaultLabel $labelResource
     * @param CollectionFactory $labelCollectionFactory
     */
    public function __construct(
        DefaultLabelFactory $labelFactory,
        ResourceDefaultLabel $labelResource,
        CollectionFactory $labelCollectionFactory
    ) {
        $this->labelFactory = $labelFactory;
        $this->labelResource = $labelResource;
        $this->labelCollectionFactory = $labelCollectionFactory;
    }

    /**
     * @return array
     */
    public function getAllOptions()
    {
        $result = [
            [
                'value' => 0,
                'label' => 'Right-top'
            ],
            [
                'value' => 1,
                'label' => 'Left-top'
            ],
            [
                'value' => 2,
                'label' => 'Left-bottom'
            ],
            [
                'value' => 3,
                'label' => 'Right-bottom'
            ],
        ];

        return $result;
    }
}
