<?php

namespace Amazingcat\Labels\Setup;

use Magento\Framework\DB\Ddl\Table;
use Magento\Framework\Setup\InstallSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

/**
 * Class InstallSchema
 * @package Amazingcat\Labels\Setup
 */
class InstallSchema implements InstallSchemaInterface
{
    const TABLE_NAME = 'amazingcat_default_labels';

    /**
     * @param SchemaSetupInterface $setup
     * @param ModuleContextInterface $context
     *
     *
     * @since version
     * @throws \Zend_Db_Exception
     */
    public function install(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $connection = $setup->getConnection();
        $table = $connection->newTable($setup->getTable(self::TABLE_NAME));
        $table
            ->addColumn(
                'id',
                Table::TYPE_INTEGER,
                null,
                [
                    'identity' => true,
                    'unsigned' => true,
                    'primary'  => true,
                    'nullable' => false,
                ]
            )
            ->addColumn(
                'name',
                Table::TYPE_TEXT,
                1023,
                [
                    'nullable' => false,
                ]
            )
            ->addColumn(
                'image_path',
                Table::TYPE_TEXT,
                1023,
                [
                    'nullable' => false,
                ]
            )
            ->addColumn(
                'position',
                Table::TYPE_INTEGER,
                10,
                [
                    'nullable' => false,
                    'default'  => 0,
                ]
            );

        $connection->createTable($table);
        $setup->endSetup();
    }
}
