<?php

namespace Amazingcat\Labels\Ui\Component\Column;

use Magento\Backend\Model\UrlInterface;
use Magento\Framework\EntityManager\EventManager;
use Magento\Framework\View\Element\UiComponent\ContextInterface;
use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Ui\Component\Listing\Columns\Column;

/**
 * Class Position
 * @package Amazingcat\Labels\Ui\Component\Column
 */
class Position extends Column
{
    /**
     * @var UrlInterface
     */
    protected $urlBuilder;

    /**
     * @var EventManager
     */
    protected $_eventManager;

    /**
     * @param ContextInterface $context
     * @param UiComponentFactory $uiComponentFactory
     * @param UrlInterface $urlBuilder
     * @param array $components
     * @param array $data
     * @param EventManager $_eventManager
     */
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        UrlInterface $urlBuilder,
        EventManager $_eventManager,
        array $components = [],
        array $data = []
    ) {
        $this->urlBuilder = $urlBuilder;
        $this->_eventManager = $_eventManager;

        parent::__construct($context, $uiComponentFactory, $components, $data);
    }

    /**
     * Prepare Data Source.
     *
     * @param array $dataSource
     *
     * @return array
     */
    public function prepareDataSource(array $dataSource)
    {
        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as &$item) {
                switch ($item['position']) {
                    case 0:
                        $item['position'] = 'Right-top';
                        break;
                    case 1:
                        $item['position'] = 'Left-top';
                        break;
                    case 2:
                        $item['position'] = 'Left-bottom';
                        break;
                    case 3:
                        $item['position'] = 'Right-bottom';
                        break;
                }
            }
        }

        $this->_eventManager->dispatch('amazingcat_labels_render_position', ['label' => $dataSource]);

        return $dataSource;
    }
}
